namespace IRDB_SDK
{
	class BaseObj_t
	{
		protected:
			BaseObj_t() {}
			BaseObj_t(const BaseObj_t& copy) = delete;

		public:
			virtual ~BaseObj_t() {}

			virtual DatabaseID_t           getBaseID()      const = 0;
			virtual DatabaseID_t           getDoipID()      const = 0;
			virtual const RelocationSet_t& getRelocations() const = 0;

			virtual void setRelocations(const RelocationSet_t& rels) = 0;
			virtual void setDoipID(Doip_t *p_dp)      = 0;
			virtual void setBaseID(DatabaseID_t p_id) = 0;

			const static int NOT_IN_DATABASE;
		        static void setInterface(DBinterface_t *dbintr);

	};

}
