namespace IRDB_SDK
{
	using namespace std;

	class Instruction_t : virtual public BaseObj_t
	{
		protected:
			Instruction_t() {}
			Instruction_t(const Instruction_t& copy) = delete;
		public:

			virtual AddressID_t*   getAddress()                     const = 0;
			virtual Function_t*    getFunction()                    const = 0;
			virtual DatabaseID_t   getOriginalAddressID()           const = 0;
			virtual Instruction_t* getFallthrough()                 const = 0;
			virtual Instruction_t* getTarget()                      const = 0;
			virtual ICFS_t*        getIBTargets()                   const = 0;
			virtual string         getDataBits()                    const = 0;
			virtual string         getCallback()                    const = 0;
			virtual string         getComment()                     const = 0;
			virtual EhProgram_t*   getEhProgram()                   const = 0;
			virtual EhCallSite_t*  getEhCallSite()                  const = 0;
			virtual AddressID_t*   getIndirectBranchTargetAddress() const = 0;
			virtual bool           isFunctionExit()                 const = 0;
			virtual string         getDisassembly()                 const = 0;
	  
			virtual void setAddress(AddressID_t* newaddr)                       = 0;
			virtual void setFunction(Function_t* func   )                       = 0;
			virtual void setOriginalAddressID(DatabaseID_t origid)              = 0;
			virtual void setFallthrough(Instruction_t* i)                       = 0;
			virtual void setTarget(Instruction_t* i)                            = 0;
			virtual void setIBTargets(ICFS_t *p_icfs)                           = 0;
			virtual void setDataBits(string orig)	                            = 0;
			virtual void setCallback(string orig)	                            = 0;
			virtual void setComment(string orig)	                            = 0;
			virtual void setEhProgram(EhProgram_t* orig)                        = 0;
			virtual void setEhCallSite(EhCallSite_t* orig)                      = 0;
			virtual void setIndirectBranchTargetAddress(AddressID_t* myIndTarg) = 0;
			virtual bool assemble(string assembly)                              = 0;

	};
}
