namespace IRDB_SDK
{

	using namespace std;

	class VariantID_t : virtual public BaseObj_t
	{

		protected:
			VariantID_t() { }

		public:
			virtual ~VariantID_t() { }

			virtual bool                isRegistered()         const = 0;
			virtual const FileSet_t&    getFiles()             const = 0; 
			virtual File_t*             getMainFile()          const = 0;
			virtual DatabaseID_t        getOriginalVariantID() const = 0; 
			virtual string              getName()              const = 0;



			virtual bool registerID()            = 0;
			virtual void setName(string newname) = 0; 
			virtual VariantID_t* clone(bool deep=true) = 0;

		// factories:
			static unique_ptr<VariantID_t> factory(const DatabaseID_t& id);
			

	};

	ostream& operator<<(ostream& out, const VariantID_t& pid);

}

