#include <sstream>

namespace IRDB_SDK
{

	using namespace std;

	template <class T>
	inline string to_hex_string (const T& t)
	{
		stringstream ss;
		ss << hex << t;
		return ss.str();
	}

	 

	template<class T> inline T strtoint(const string& s)
	{
		stringstream str(s);
		auto off=T();

		str >> off;

		return off;
	}

	// nb: relies on srand() being previously set 
	template <typename IterType, typename Funct>
	inline Funct for_randomOrder_each(const IterType &b, const IterType & e, const Funct &callback)
	{
		auto m=map<int,const typename iterator_traits<IterType>::value_type *>();
		for_each(b,e, [&](const typename iterator_traits<IterType>::value_type & o)
		{
		       while(true)
		       {
			       auto rn=rand();
			       if(m.find(rn)==m.end())
			       {
				       m[rn]=&o;
				       break;
			       }
		       }
		});
		for_each(m.begin(), m.end(), [&](const pair<int,const typename iterator_traits<IterType>::value_type *> &p)
		{
		       callback(*p.second);
		});
		return callback;
	}



}


